/*
Scribble - filesys.js
Copyright (c) 2012 Greg Sydney-Smith

This file is part of Scribble.

Scribble is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later version.

Scribble is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with Scribble.  If not, see <http://www.gnu.org/licenses/>.

Revision History:
2012-01-07 Initial Release.
*/

function filesys() {

    this.name = function () { return "localStorage v1.00"; };

    this.available = function () {
        try {
            return 'localStorage' in window && window['localStorage'] !== null;
        } catch(e) {
            return false;
        }
    };

    this.dir = function() {
        var names = Array();

        if (!this.available()) return names;

        for (var i=0; i<localStorage.length; i++)
          names[i] = localStorage.key(i);
        return names;
    }

    this.load = function(fn) {
        if (!this.available()) return "";
        return localStorage.getItem(fn);
    }

    this.save = function(fn,data) {
        if (!this.available()) return;
        localStorage.setItem(fn,data);
    }

    this.del = function(fn) {
        if (!this.available()) return;
        localStorage.removeItem(fn);
    }
}


