/*
Scribble - palette.js
Copyright (C) 2012 Greg Sydney-Smith

This file is part of Scribble.

Scribble is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later version.

Scribble is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with Scribble.  If not, see <http://www.gnu.org/licenses/>.

Revision History:
2012-12-31 Initial release.
*/

function Palette() {
    var paletteId= "";
    var red  = 0;
    var green= 0;
    var blue = 0;
    var cols = 0;
    var reds = [];
    var greens=[];
    var blues =[];
        
    this.setCols = function (n) { cols=n; };

    this.init = function () {
    };
    
    this.setColor = function (r,c,val) {
        switch (r) {
        case 1 : red  =val; highlight(reds,  1,c); break;
        case 2 : green=val; highlight(greens,2,c); break;
        default: blue =val; highlight(blues, 3,c);
        }
    };
    this.getColor = function () {
        return "rgb("+red+","+green+","+blue+")";
    };

    function highlight(a,r,c) {
        for (var i=0; i<a.length; i++)
//            document.getElementById(paletteId+r+""+(1+i)).style.border= "2px solid black";
//        document.getElementById(paletteId+r+""+c).style.border= "8px solid white";
            document.getElementById(paletteId+r+""+(1+i)).innerText= "";
        document.getElementById(paletteId+r+""+c).innerText= "*";
    }
    
    this.create = function (parent,x0,y0,w,h,id,func) {
        var dy= h/3;
        paletteId= parent+id;
        reds   = createRow(parent,x0,y0     ,w,0.9*dy,id,1,"r",func);
        blues  = createRow(parent,x0,y0+  dy,w,0.9*dy,id,2,"g",func);
        greens = createRow(parent,x0,y0+2*dy,w,0.9*dy,id,3,"b",func);
    }

    function createRow (parent,x0,y,w,h,id,row,rgb,func) {
        var i = 0;
        var dx= w/cols;
        var args = [];
        var a = [];
        
        var x=x0;
        for (var c=0; c<cols; c++) {
            var myId= id+row+""+(1+c);
            var n   = parseInt(c*255/(cols-1),10);
            var bck = (rgb=="r") ? ""+n+",0,0" : (rgb=="g") ? "0,"+n+",0" : "0,0,"+n;
            args[0] = func+"("+row+","+(1+c)+","+n+")";
            a[i]    = new GuiBtn2(parent,x,y,0.9*dx,h,myId,"",args);
            document.getElementById(parent+myId).style.backgroundColor= "rgb("+bck+")";
            x += dx;
            i++;
        }
        return a;
    }

    this.resize = function (aw,ah) {
        for (var i=0; i<reds.length;   i++)  reds[i  ].resize(aw,ah);
        for (var i=0; i<greens.length; i++)  greens[i].resize(aw,ah);
        for (var i=0; i<blues.length;  i++)  blues[i ].resize(aw,ah);
    };

}
